# -*- coding: utf-8 -*-
"""
Created on Tue Jan 14 13:33:16 2020

@author: bgregor
"""

# An example of using scipy.stats.linregress to fit a line
# to some data.

import numpy as np
import scipy.stats as stats

from matplotlib import pyplot as plt

# Some pre-calculated X & Y points
x = np.asarray([0.0,0.5,1.0,1.5,2.0,2.5,3.0,
                3.5,4.0,4.5,5.0,5.5,6.0,6.5,
                7.0,7.5,8.0,8.5,9.0,9.5,10.0])

y = np.asarray([-0.2,2.6,5.5,8.6,11.2,10.2,16.7,
                21.0,17.9,25.7,26.3,35.0,33.0,
                32.5,40.4,43.6,35.3,48.7,52.3,58.7,56.4])


# Call the linear regression
slope,intercept,r_val,p_val,err = stats.linregress(x,y)

print('slope: %s   intercept: %s' % (slope,intercept))

# Plot 'em
plt.plot(x,y,'ro')
# From the X points calculate fitted Y points
y_fit = slope * x + intercept
#add to the plot
plt.plot(x,y_fit,'b--')
plt.legend(['data points','linear fit'])
plt.show()
