# -*- coding: utf-8 -*-
"""
Some basics of numpy

@author: bgregor
"""

# The usual convention
import numpy as np

# Create a vector, i.e. a rank 1 array
a = np.array([10, 20, 30])   
# a.shape returns a tuple of the array dimensions
print('Shape of a: %s' % a.shape)
          
# Index like a list 
print('Elements of a: (%s, %s, %s)' % (a[0], a[1], a[2],)) 

# Change an element of the array
a[0] = -5             
# Prints like a list
print('Updated a: %s' % a)

# Create a 2D matrix, i.e. a rank 2 array
b = np.array([[10,20,30],[40,50,60]])    
print('shape of b: (%s, %s)' %  b.shape )
# Print the b matrix:
print('b: %s' % b)

# Print some elements. Note the indexing has changed:  [row,col]
print('b[0,0]: %s' % (b[0,0],))
print('b[1,1]: %s' % (b[1,1],))  

# Some very Matlab-like functions exist to create arrays
# Create an array of all zeros
zeros = np.zeros((2,4))   
print('zeros:\n%s' % zeros)              

# an array of all 1's
ones = np.ones((3,2,4))
# What do you think it'll print?     
print('ones: \n%s' % ones)            
 
# The identity matrix
ident = np.eye(3)        
print('identity:\n%s' %  ident)         

# A 3x4 matrix of random numbers uniformly
# distributed between 0 and 1.  Use the random
# function from the numpy random library.
ran_nums = np.random.random([3,4])
print('Some random numbers:\n%s' % ran_nums)

# Create a 1D vector of 100 elements that is uninitialized
# This creates an ndarray object directly with no list creation.
print('Reshaping:')
vec = np.ndarray([100])
print('%s' % vec.shape)
# Reshape that into a 25 row x 4 column matrix
vec = vec.reshape([25,4])
print('%s,%s' % vec.shape)


# To have a single loop visit every element of an ndarray 
# regardless of # of dimensions use the ndenumerate function
for idx, elem in np.ndenumerate(ran_nums):
    print('idx: %s   elem: %.2f   array[idx]: %.2f' % (idx,elem, ran_nums[idx]))
  